/*
 * Start a virtual machine with a single vcpu bound to host cpu 'n'
 */

#include <sys/param.h>
#include <sys/kernel.h>
#include <sys/systm.h>
#include <sys/sysctl.h>
#include <sys/module.h>

static int
sysctl_cr4_val(SYSCTL_HANDLER_ARGS)
{
	int error;
	u_long val;

	val = rcr4();
	error = sysctl_handle_long(oidp, &val, 0, req);
	if (error || req->newptr == NULL)
		return (error);

	load_cr4(val);
	return (0);
}
SYSCTL_NODE(_debug, OID_AUTO, cr4, CTLFLAG_RW, 0, "");
SYSCTL_PROC(_debug_cr4, OID_AUTO, val, CTLTYPE_ULONG|CTLFLAG_RW, 0, 0, 
    sysctl_cr4_val, "LU", "");

static int
cr4_modevent(module_t mod, int type, void *unused)
{

        switch (type) {
        case MOD_LOAD:
		break;
	case MOD_UNLOAD:
		break;
	default:
		return (EINVAL);
	}

	return (0);
}

static moduledata_t cr4_mod_data= {
	"cr4",
	cr4_modevent,
};

DECLARE_MODULE(test, cr4_mod_data, SI_SUB_SMP + 1, SI_ORDER_ANY);
